Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 368)
@@ -61,4 +61,7 @@
 // ====================================================================================================================
 
+#if H_MV
+class TAppDecTop;
+#endif
 /// decoder class
 class TDecTop
@@ -72,5 +75,9 @@
 
   TComList<TComPic*>      m_cListPic;         //  Dynamic buffer
+#if H_MV
+  static ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
+#else
   ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
+#endif
   TComSlice*              m_apcSlicePilot;
   
@@ -98,4 +105,14 @@
   Bool                    m_bFirstSliceInPicture;
   Bool                    m_bFirstSliceInSequence;
+#if H_MV
+  // For H_MV m_bFirstSliceInSequence indicates first slice in sequence of the particular layer  
+  Int                     m_layerId;
+  Int                     m_viewId;
+  TComPicLists*           m_ivPicLists;
+  std::vector<TComPic*>   m_refPicSetInterLayer; 
+#if H_3D
+  Bool                    m_isDepth;
+#endif
+#endif
 
 public:
@@ -109,10 +126,33 @@
 
   Void  init();
+#if H_MV  
+  Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayer );
+#else  
   Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay);
+#endif
   
   Void  deletePicBuffer();
 
+#if H_MV
+  Void endPicDecoding(Int& poc, TComList<TComPic*>*& rpcListPic,  std::vector<Int>& targetDecLayerIdSet);  
+#else
   Void executeLoopFilters(Int& poc, TComList<TComPic*>*& rpcListPic);
+#endif
   
+#if H_MV    
+  TComPic*                getPic                ( Int poc );
+  TComList<TComPic*>*     getListPic            ()               { return &m_cListPic;  }  
+  Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
+  
+  Int                     getCurrPoc            ()               { return m_apcSlicePilot->getPOC(); }
+  Void                    setLayerId            ( Int layer)     { m_layerId = layer;   }
+  Int                     getLayerId            ()               { return m_layerId;    }
+  Void                    setViewId             ( Int viewId  )  { m_viewId  = viewId;  }
+  Int                     getViewId             ()               { return m_viewId;     }  
+#if H_3D    
+  Void                    setIsDepth            ( Bool isDepth ) { m_isDepth = isDepth; }
+  Bool                    getIsDepth            ()               { return m_isDepth;    }
+#endif
+#endif
 protected:
   Void  xGetNewPicBuffer  (TComSlice* pcSlice, TComPic*& rpcPic);
@@ -120,5 +160,10 @@
 
   Void      xActivateParameterSets();
+#if H_MV  
+  TComPic*  xGetPic( Int layerId, Int poc ); 
+  Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag );  
+#else
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay);
+#endif
   Void      xDecodeVPS();
   Void      xDecodeSPS();
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/NALwrite.cpp
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/NALwrite.cpp	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/NALwrite.cpp	(revision 368)
@@ -53,5 +53,9 @@
   bsNALUHeader.write(0,1);                    // forbidden_zero_bit
   bsNALUHeader.write(nalu.m_nalUnitType, 6);  // nal_unit_type
+#if H_MV
+  bsNALUHeader.write(nalu.m_layerId, 6);      // layerId       
+#else
   bsNALUHeader.write(nalu.m_reservedZero6Bits, 6);                   // nuh_reserved_zero_6bits
+#endif
   bsNALUHeader.write(nalu.m_temporalId+1, 3); // nuh_temporal_id_plus1
 
@@ -142,5 +146,9 @@
 {
   naluDest.m_nalUnitType = naluSrc.m_nalUnitType;
+#if H_MV
+  naluDest.m_layerId  = naluSrc.m_layerId;
+#else
   naluDest.m_reservedZero6Bits  = naluSrc.m_reservedZero6Bits;
+#endif
   naluDest.m_temporalId  = naluSrc.m_temporalId;
   naluDest.m_Bitstream   = naluSrc.m_Bitstream;
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/NALwrite.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/NALwrite.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/NALwrite.h	(revision 368)
@@ -57,6 +57,14 @@
     NalUnitType nalUnitType,
     UInt temporalID = 0,
+#if H_MV
+    Int layerId = 0)
+#else
     UInt reserved_zero_6bits = 0)
+#endif
+#if H_MV
+  : NALUnit(nalUnitType, temporalID, layerId)
+#else
   : NALUnit(nalUnitType, temporalID, reserved_zero_6bits)
+#endif
   , m_Bitstream()
   {}
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncAnalyze.cpp
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncAnalyze.cpp	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncAnalyze.cpp	(revision 368)
@@ -36,5 +36,7 @@
 */
 
+#if !H_MV
 #include "TEncAnalyze.h"
+#endif
 
 //! \ingroup TLibEncoder
@@ -45,8 +47,10 @@
 //////////////////////////////////////////////////////////////////////
 
+#if !H_MV
 TEncAnalyze             m_gcAnalyzeAll;
 TEncAnalyze             m_gcAnalyzeI;
 TEncAnalyze             m_gcAnalyzeP;
 TEncAnalyze             m_gcAnalyzeB;
+#endif
 
 //! \}
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncAnalyze.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 368)
@@ -150,8 +150,10 @@
 };
 
+#if !H_MV
 extern TEncAnalyze             m_gcAnalyzeAll;
 extern TEncAnalyze             m_gcAnalyzeI;
 extern TEncAnalyze             m_gcAnalyzeP;
 extern TEncAnalyze             m_gcAnalyzeB;
+#endif
 
 //! \}
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 368)
@@ -549,5 +549,11 @@
   }
 
+#if H_MV
+  WRITE_FLAG( 1, "sps_extension_flag" );
+
+  WRITE_FLAG( pcSPS->getInterViewMvVertConstraintFlag() ? 1 : 0, "inter_view_mv_vert_constraint_flag" );
+#else
   WRITE_FLAG( 0, "sps_extension_flag" );
+#endif
 }
 
@@ -556,9 +562,17 @@
   WRITE_CODE( pcVPS->getVPSId(),                    4,        "vps_video_parameter_set_id" );
   WRITE_CODE( 3,                                    2,        "vps_reserved_three_2bits" );
+#if H_MV
+  WRITE_CODE( pcVPS->getMaxLayers() - 1,            6,        "vps_max_layers_minus1" );
+#else
   WRITE_CODE( 0,                                    6,        "vps_reserved_zero_6bits" );
+#endif
   WRITE_CODE( pcVPS->getMaxTLayers() - 1,           3,        "vps_max_sub_layers_minus1" );
   WRITE_FLAG( pcVPS->getTemporalNestingFlag(),                "vps_temporal_id_nesting_flag" );
   assert (pcVPS->getMaxTLayers()>1||pcVPS->getTemporalNestingFlag());
+#if H_MV
+  WRITE_CODE( 0xffff,                              16,        "vps_extension_offset" );
+#else
   WRITE_CODE( 0xffff,                              16,        "vps_reserved_ffff_16bits" );
+#endif
   codePTL( pcVPS->getPTL(), true, pcVPS->getMaxTLayers() - 1 );
 #if SIGNAL_BITRATE_PICRATE_IN_VPS
@@ -583,6 +597,11 @@
 
   assert( pcVPS->getNumHrdParameters() <= MAX_VPS_NUM_HRD_PARAMETERS );
+#if H_MV
+  assert( pcVPS->getMaxNuhLayerId() < MAX_VPS_NUH_LAYER_ID_PLUS1 );
+  WRITE_CODE( pcVPS->getMaxNuhLayerId(), 6,                 "vps_max_nuh_layer_id" );
+#else
   assert( pcVPS->getMaxNuhReservedZeroLayerId() < MAX_VPS_NUH_RESERVED_ZERO_LAYER_ID_PLUS1 );
   WRITE_CODE( pcVPS->getMaxNuhReservedZeroLayerId(), 6,     "vps_max_nuh_reserved_zero_layer_id" );
+#endif
   pcVPS->setMaxOpSets(1);
   WRITE_UVLC( pcVPS->getMaxOpSets() - 1,                    "vps_max_op_sets_minus1" );
@@ -590,5 +609,9 @@
   {
     // Operation point set
+#if H_MV
+    for( UInt i = 0; i <= pcVPS->getMaxNuhLayerId(); i ++ )
+#else
     for( UInt i = 0; i <= pcVPS->getMaxNuhReservedZeroLayerId(); i ++ )
+#endif
     {
       // Only applicable for version 1
@@ -631,5 +654,69 @@
   }
 #endif
+#if H_MV
+  WRITE_FLAG( 1,                                             "vps_extension_flag" );
+
+  m_pcBitIf->writeAlignOne();                        
+
+  WRITE_FLAG( pcVPS->getAvcBaseLayerFlag() ? 1 : 0,          "avc_base_layer_flag" );
+  WRITE_FLAG( pcVPS->getSplittingFlag() ? 1 : 0,             "splitting_flag" );
+  
+  for( Int type = 0; type < MAX_NUM_SCALABILITY_TYPES; type++ )
+  {
+    WRITE_FLAG( pcVPS->getScalabilityMask( type ) ? 1 : 0,   "scalability_mask[i]" );
+  }
+
+  for( Int sIdx = 0; sIdx < pcVPS->getNumScalabilityTypes( ); sIdx++ )
+  {
+    WRITE_CODE( pcVPS->getDimensionIdLen( sIdx ) - 1 , 3,    "dimension_id_len_minus1[j]");    
+  }
+
+  WRITE_FLAG( pcVPS->getVpsNuhLayerIdPresentFlag() ? 1 : 0,  "vps_nuh_layer_id_present_flag");
+
+  for( Int layer = 1; layer <= pcVPS->getMaxLayers() - 1; layer++ )
+  {
+    if (pcVPS->getVpsNuhLayerIdPresentFlag() )
+      WRITE_CODE( pcVPS->getLayerIdInNuh( layer ), 6,          "layer_id_in_nuh[i]");
+    for( Int sIdx = 0; sIdx < pcVPS->getNumScalabilityTypes() ; sIdx++ )
+    {      
+      WRITE_CODE( pcVPS->getDimensionId( layer, sIdx ), pcVPS->getDimensionIdLen( sIdx ), "dimension_id[i][j]");      
+    }
+  }
+
+  for( Int layerSet = 1; layerSet <= pcVPS->getMaxOpSets() - 1; layerSet++ )
+  {
+    WRITE_FLAG( pcVPS->getVpsProfilePresentFlag( layerSet ) ? 1 : 0, "vps_profile_present_flag[lsIdx]" );
+    if( pcVPS->getVpsProfilePresentFlag( layerSet ) == false )
+    {
+      WRITE_UVLC( pcVPS->getProfileLayerSetRefMinus1( layerSet ), "profile_layer_set_ref_minus1[lsIdx]" );
+    }
+    codePTL( pcVPS->getPTL( layerSet ), pcVPS->getVpsProfilePresentFlag( layerSet ), pcVPS->getMaxTLayers() - 1 );
+  }
+
+  WRITE_UVLC( pcVPS->getNumOutputLayerSets(),                "num_output_layer_sets" );
+
+  for( Int layerSet = 0; layerSet < pcVPS->getNumOutputLayerSets(); layerSet++ )
+  {
+    WRITE_UVLC( pcVPS->getOutputLayerSetIdx( layerSet ),      "output_layer_set_idx[i]" );
+    for( Int layer = 0; layer <= pcVPS->getMaxNuhLayerId(); layer++ )
+    {
+      if( pcVPS->getLayerIdIncludedFlag( pcVPS->getOutputLayerSetIdx( layerSet ), layer ) == true )
+      {
+        WRITE_FLAG( pcVPS->getOutputLayerFlag( layerSet, layer ) ? 1 : 0, "output_layer_flag" );
+      }
+    }
+  }
+
+  for( Int i = 1; i <= pcVPS->getMaxLayers() - 1; i++ )
+  {
+    for( Int j = 0; j < i; j++ )
+    {
+      WRITE_FLAG( pcVPS->getDirectDependencyFlag( i, j ),    "direct_dependency_flag[i][j]" );
+    }
+  }
+  WRITE_FLAG( 0,                                             "vps_extension2_flag" );
+#else
   WRITE_FLAG( 0,                     "vps_extension_flag" );
+#endif
   
   //future extensions here..
@@ -1004,8 +1091,12 @@
   for (Int i = 0; i < maxNumSubLayersMinus1; i++)
   {
+#if !H_MV
     if(profilePresentFlag)
     {
+#endif
       WRITE_FLAG( pcPTL->getSubLayerProfilePresentFlag(i), "sub_layer_profile_present_flag[i]" );
-    }
+#if !H_MV
+    }
+#endif
     
     WRITE_FLAG( pcPTL->getSubLayerLevelPresentFlag(i),   "sub_layer_level_present_flag[i]" );
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncCfg.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncCfg.h	(revision 368)
@@ -69,4 +69,9 @@
   Int m_numRefIdc;
   Int m_refIdc[MAX_NUM_REF_PICS+1];
+#if H_MV
+  Int m_numInterViewRefPics;
+  Int m_interViewRefs    [MAX_NUM_REF_PICS];
+  Int m_interViewRefPosL[2][MAX_NUM_REF_PICS];  
+#endif
   GOPEntry()
   : m_POC(-1)
@@ -83,8 +88,15 @@
   , m_deltaRPS(0)
   , m_numRefIdc(0)
+#if H_MV
+  , m_numInterViewRefPics(0)
+#endif
   {
     ::memset( m_referencePics, 0, sizeof(m_referencePics) );
     ::memset( m_usedByCurrPic, 0, sizeof(m_usedByCurrPic) );
     ::memset( m_refIdc,        0, sizeof(m_refIdc) );
+#if H_MV
+    ::memset( m_interViewRefs,   0, sizeof(m_interViewRefs) );
+    ::memset( m_interViewRefPosL[0], -1, sizeof(m_interViewRefPosL[0]) );    ::memset( m_interViewRefPosL[1], -1, sizeof(m_interViewRefPosL[1]) );
+#endif
   }
 };
@@ -127,5 +139,9 @@
   UInt      m_uiDecodingRefreshType;            ///< the type of decoding refresh employed for the random access.
   Int       m_iGOPSize;
+#if H_MV
+  GOPEntry  m_GOPList[MAX_GOP+1];
+#else
   GOPEntry  m_GOPList[MAX_GOP];
+#endif
   Int       m_extraRPSs;
   Int       m_maxDecPicBuffering[MAX_TLAYER];
@@ -337,8 +353,24 @@
   Bool      m_useStrongIntraSmoothing;                        ///< enable the use of strong intra smoothing (bi_linear interpolation) for 32x32 blocks when reference samples are flat.
 
+#if H_MV
+  Int       m_layerId;
+  Int       m_layerIdInVps;
+  Int       m_viewId;
+#if H_3D
+  Bool      m_isDepth;
+#endif
+#endif
 public:
   TEncCfg()
   : m_puiColumnWidth()
   , m_puiRowHeight()
+#if H_MV
+  , m_layerId(-1)
+  , m_layerIdInVps(-1)
+  , m_viewId(-1)
+#if H_3D
+  , m_isDepth(false)
+#endif
+#endif
   {}
 
@@ -362,9 +394,25 @@
   Void      setFramesToBeEncoded            ( Int   i )      { m_framesToBeEncoded = i; }
   
+#if H_MV
+  Void      setLayerId                       ( Int layerId )      { m_layerId = layerId; }
+  Int       getLayerId                       ()                   { return m_layerId;    }
+  Int       getLayerIdInVps                  ()                   { return m_layerIdInVps; }
+  Void      setLayerIdInVps                  ( Int layerIdInVps)  { m_layerIdInVps = layerIdInVps; }
+  Void      setViewId                        ( Int viewId  )      { m_viewId  = viewId;  }
+  Int       getViewId                        ()                   { return m_viewId;    }
+#if H_3D
+  Void      setIsDepth                       ( Bool isDepth )   { m_isDepth = isDepth; }
+  Bool      getIsDepth                       ()                 { return m_isDepth; }
+#endif
+#endif
   //====== Coding Structure ========
   Void      setIntraPeriod                  ( Int   i )      { m_uiIntraPeriod = (UInt)i; }
   Void      setDecodingRefreshType          ( Int   i )      { m_uiDecodingRefreshType = (UInt)i; }
   Void      setGOPSize                      ( Int   i )      { m_iGOPSize = i; }
+#if H_MV
+  Void      setGopList                      ( GOPEntry*  GOPList ) {  for ( Int i = 0; i < MAX_GOP+1; i++ ) m_GOPList[i] = GOPList[i]; }
+#else
   Void      setGopList                      ( GOPEntry*  GOPList ) {  for ( Int i = 0; i < MAX_GOP; i++ ) m_GOPList[i] = GOPList[i]; }
+#endif
   Void      setExtraRPSs                    ( Int   i )      { m_extraRPSs = i; }
   GOPEntry  getGOPEntry                     ( Int   i )      { return m_GOPList[i]; }
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 368)
@@ -100,4 +100,12 @@
 #endif
 #endif
+#if H_MV
+  m_layerId      = 0;
+  m_viewId       = 0;
+  m_pocLastCoded = -1; 
+#if H_3D
+  m_isDepth = false;
+#endif
+#endif
   return;
 }
@@ -139,4 +147,12 @@
   m_totalCoded         = 0;
 
+#if H_MV
+  m_ivPicLists           = pcTEncTop->getIvPicLists(); 
+  m_layerId              = pcTEncTop->getLayerId();
+  m_viewId               = pcTEncTop->getViewId();
+#if H_3D
+  m_isDepth              = pcTEncTop->getIsDepth();
+#endif
+#endif
 }
 
@@ -342,5 +358,16 @@
 // Public member functions
 // ====================================================================================================================
+#if H_MV
+Void TEncGOP::initGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP)
+{
+  xInitGOP( iPOCLast, iNumPicRcvd, rcListPic, rcListPicYuvRecOut );
+  m_iNumPicCoded = 0;
+}
+#endif
+#if H_MV
+Void TEncGOP::compressPicInGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP, Int iGOPid)
+#else
 Void TEncGOP::compressGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP)
+#endif
 {
   TComPic*        pcPic;
@@ -354,7 +381,9 @@
   TComOutputBitstream* pcSubstreamsOut = NULL;
 
+#if !H_MV
   xInitGOP( iPOCLast, iNumPicRcvd, rcListPic, rcListPicYuvRecOut );
   
   m_iNumPicCoded = 0;
+#endif
   SEIPictureTiming pictureTimingSEI;
 #if L0208_SOP_DESCRIPTION_SEI
@@ -379,5 +408,7 @@
   UInt *accumNalsDU = NULL;
   SEIDecodingUnitInfo decodingUnitInfoSEI;
+#if !H_MV
   for ( Int iGOPid=0; iGOPid < m_iGopSize; iGOPid++ )
+#endif
   {
     UInt uiColDir = 1;
@@ -438,5 +469,10 @@
     if(pocCurr>=m_pcCfg->getFramesToBeEncoded())
     {
+#if H_MV
+      delete pcBitstreamRedirect;
+      return;
+#else
       continue;
+#endif
     }
 
@@ -459,4 +495,15 @@
     pcSlice->setLastIDR(m_iLastIDR);
     pcSlice->setSliceIdx(0);
+#if H_MV
+    pcPic  ->setLayerId     ( getLayerId() );
+    pcPic  ->setViewId      ( getViewId()  );
+    pcSlice->setLayerId     ( getLayerId() );
+    pcSlice->setViewId      ( getViewId()  );
+    pcSlice->setVPS         ( m_pcEncTop->getVPS() );
+#if H_3D
+    pcPic  ->setIsDepth( getIsDepth() );
+    pcSlice->setIsDepth( getIsDepth() );
+#endif
+#endif
     //set default slice level flag to the same as SPS level flag
     pcSlice->setLFCrossSliceBoundaryFlag(  pcSlice->getPPS()->getLoopFilterAcrossSlicesEnabledFlag()  );
@@ -496,10 +543,22 @@
     }
 
-    if(pcSlice->getSliceType()==B_SLICE&&m_pcCfg->getGOPEntry(iGOPid).m_sliceType=='P')
-    {
-      pcSlice->setSliceType(P_SLICE);
-    }
+#if H_MV
     // Set the nal unit type
     pcSlice->setNalUnitType(getNalUnitType(pocCurr, m_iLastIDR));
+    if( pcSlice->getSliceType() == B_SLICE )
+    {
+      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'P' ) 
+      { 
+        pcSlice->setSliceType( P_SLICE );
+      }
+    }
+#else
+    if(pcSlice->getSliceType()==B_SLICE&&m_pcCfg->getGOPEntry(iGOPid).m_sliceType=='P')
+    {
+      pcSlice->setSliceType(P_SLICE);
+    }
+    // Set the nal unit type
+    pcSlice->setNalUnitType(getNalUnitType(pocCurr, m_iLastIDR));
+#endif
     if(pcSlice->getTemporalLayerNonReferenceFlag())
     {
@@ -589,6 +648,13 @@
     refPicListModification->setRefPicListModificationFlagL0(0);
     refPicListModification->setRefPicListModificationFlagL1(0);
+#if H_MV
+    pcSlice->createAndApplyIvReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer ); 
+    pcSlice->setNumRefIdx(REF_PIC_LIST_0,min(m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid ).m_numRefPicsActive,( pcSlice->getRPS()->getNumberOfPictures() + (Int) m_refPicSetInterLayer.size() ) ) );
+    pcSlice->setNumRefIdx(REF_PIC_LIST_1,min(m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid ).m_numRefPicsActive,( pcSlice->getRPS()->getNumberOfPictures() + (Int) m_refPicSetInterLayer.size() ) ) );
+    xSetRefPicListModificationsMvc( pcSlice, pocCurr, iGOPid );    
+#else
     pcSlice->setNumRefIdx(REF_PIC_LIST_0,min(m_pcCfg->getGOPEntry(iGOPid).m_numRefPicsActive,pcSlice->getRPS()->getNumberOfPictures()));
     pcSlice->setNumRefIdx(REF_PIC_LIST_1,min(m_pcCfg->getGOPEntry(iGOPid).m_numRefPicsActive,pcSlice->getRPS()->getNumberOfPictures()));
+#endif
 
 #if ADAPTIVE_QP_SELECTION
@@ -597,11 +663,25 @@
 
     //  Set reference list
+#if H_MV    
+    pcSlice->setRefPicList( rcListPic, m_refPicSetInterLayer );
+#else
     pcSlice->setRefPicList ( rcListPic );
+#endif
 
     //  Slice info. refinement
+#if H_MV
+    if ( pcSlice->getSliceType() == B_SLICE )
+    {
+      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() == true && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'P' ) 
+      { 
+        pcSlice->setSliceType( P_SLICE ); 
+      }
+    }
+#else
     if ( (pcSlice->getSliceType() == B_SLICE) && (pcSlice->getNumRefIdx(REF_PIC_LIST_1) == 0) )
     {
       pcSlice->setSliceType ( P_SLICE );
     }
+#endif
 #if !L0034_COMBINED_LIST_CLEANUP
     if (pcSlice->getSliceType() != B_SLICE || !pcSlice->getSPS()->getUseLComb())
@@ -1020,4 +1100,8 @@
     {
       OutputNALUnit nalu(NAL_UNIT_VPS);
+#if H_MV
+      if( getLayerId() == 0 )
+      {
+#endif
       m_pcEntropyCoder->setBitstream(&nalu.m_Bitstream);
       m_pcEntropyCoder->encodeVPS(m_pcEncTop->getVPS());
@@ -1028,5 +1112,10 @@
 #endif
 
+#if H_MV
+      }
+      nalu = NALUnit(NAL_UNIT_SPS, 0, getLayerId());
+#else
       nalu = NALUnit(NAL_UNIT_SPS);
+#endif
       m_pcEntropyCoder->setBitstream(&nalu.m_Bitstream);
       if (m_bSeqFirst)
@@ -1061,5 +1150,9 @@
 #endif
 
+#if H_MV
+      nalu = NALUnit(NAL_UNIT_PPS, 0, getLayerId());
+#else
       nalu = NALUnit(NAL_UNIT_PPS);
+#endif
       m_pcEntropyCoder->setBitstream(&nalu.m_Bitstream);
       m_pcEntropyCoder->encodePPS(pcSlice->getPPS());
@@ -1383,5 +1476,9 @@
           m_pcEntropyCoder->resetEntropy      ();
           /* start slice NALunit */
+#if H_MV
+          OutputNALUnit nalu( pcSlice->getNalUnitType(), pcSlice->getTLayer(), getLayerId() );
+#else
           OutputNALUnit nalu( pcSlice->getNalUnitType(), pcSlice->getTLayer() );
+#endif
           Bool sliceSegment = (!pcSlice->isNextSlice());
           if (!sliceSegment)
@@ -1610,5 +1707,10 @@
       }
 
+#if !H_3D
       pcPic->compressMotion(); 
+#endif
+#if H_MV
+      m_pocLastCoded = pcPic->getPOC();
+#endif
       //-- For time output for each slice
       Double dEncTime = (Double)(clock()-iBeforeTime) / CLOCKS_PER_SEC;
@@ -1921,4 +2023,9 @@
 
       pcPic->setReconMark   ( true );
+#if H_MV
+      TComSlice::markIvRefPicsAsShortTerm( m_refPicSetInterLayer );  
+      std::vector<Int> temp; 
+      TComSlice::markIvRefPicsAsUnused   ( m_ivPicLists, temp, pcPic->getSlice(0)->getVPS(), m_layerId, pcPic->getPOC() ); 
+#endif
       m_bFirst = false;
       m_iNumPicCoded++;
@@ -1941,7 +2048,10 @@
   if( accumNalsDU != NULL) delete accumNalsDU;
 
+#if !H_MV
   assert ( m_iNumPicCoded == iNumPicRcvd );
+#endif
 }
 
+#if !H_MV
 Void TEncGOP::printOutSummary(UInt uiNumAllPicCoded)
 {
@@ -1979,4 +2089,5 @@
   printf("\nRVM: %.3lf\n" , xCalculateRVM());
 }
+#endif
 
 Void TEncGOP::preLoopFilterPicAll( TComPic* pcPic, UInt64& ruiDist, UInt64& ruiBits )
@@ -2254,17 +2365,33 @@
 
   //===== add PSNR =====
+#if H_MV
+  m_pcEncTop->getAnalyzeAll()->addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#else
   m_gcAnalyzeAll.addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#endif
   TComSlice*  pcSlice = pcPic->getSlice(0);
   if (pcSlice->isIntra())
   {
+#if H_MV
+    m_pcEncTop->getAnalyzeI()->addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#else
     m_gcAnalyzeI.addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#endif
   }
   if (pcSlice->isInterP())
   {
+#if H_MV
+    m_pcEncTop->getAnalyzeP()->addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#else
     m_gcAnalyzeP.addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#endif
   }
   if (pcSlice->isInterB())
   {
+#if H_MV
+    m_pcEncTop->getAnalyzeB()->addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#else
     m_gcAnalyzeB.addResult (dYPSNR, dUPSNR, dVPSNR, (Double)uibits);
+#endif
   }
 
@@ -2273,4 +2400,14 @@
 
 #if ADAPTIVE_QP_SELECTION
+#if H_MV
+  printf("Layer %3d   POC %4d TId: %1d ( %c-SLICE, nQP %d QP %d ) %10d bits",
+    pcSlice->getLayerId(),
+    pcSlice->getPOC(),
+    pcSlice->getTLayer(),
+    c,
+    pcSlice->getSliceQpBase(),
+    pcSlice->getSliceQp(),
+    uibits );
+#else
   printf("POC %4d TId: %1d ( %c-SLICE, nQP %d QP %d ) %10d bits",
          pcSlice->getPOC(),
@@ -2280,4 +2417,14 @@
          pcSlice->getSliceQp(),
          uibits );
+#endif
+#else
+#if H_MV
+  printf("Layer %3d   POC %4d TId: %1d ( %c-SLICE, QP %d ) %10d bits",
+    pcSlice->getLayerId(),
+    pcSlice->getPOC()-pcSlice->getLastIDR(),
+    pcSlice->getTLayer(),
+    c,
+    pcSlice->getSliceQp(),
+    uibits );
 #else
   printf("POC %4d TId: %1d ( %c-SLICE, QP %d ) %10d bits",
@@ -2287,4 +2434,5 @@
          pcSlice->getSliceQp(),
          uibits );
+#endif
 
 #endif
@@ -2297,5 +2445,16 @@
     for (Int iRefIndex = 0; iRefIndex < pcSlice->getNumRefIdx(RefPicList(iRefList)); iRefIndex++)
     {
+#if H_MV
+      if( pcSlice->getLayerId() != pcSlice->getRefLayerId( RefPicList(iRefList), iRefIndex ) )
+      {
+        printf( "V%d ", pcSlice->getRefLayerId( RefPicList(iRefList), iRefIndex ) );
+      }
+      else
+      {
+#endif
       printf ("%d ", pcSlice->getRefPOC(RefPicList(iRefList), iRefIndex)-pcSlice->getLastIDR());
+#if H_MV
+      }
+#endif
     }
     printf("]");
@@ -2663,3 +2822,82 @@
 }
 #endif
+#if H_MV
+Void TEncGOP::xSetRefPicListModificationsMvc( TComSlice* pcSlice, UInt uiPOCCurr, UInt iGOPid )
+{ 
+  TComVPS* vps = pcSlice->getVPS(); 
+  Int layer    = pcSlice->getLayerIdInVps( ); 
+  
+  if( pcSlice->getSliceType() == I_SLICE || !(pcSlice->getPPS()->getListsModificationPresentFlag()) || vps->getNumDirectRefLayers( layer ) == 0 )
+  {
+    return;
+  }
+
+  // analyze inter-view modifications
+  GOPEntry ge = m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && ( layer > 0) ) ? MAX_GOP : iGOPid );
+
+  TComRefPicListModification* refPicListModification = pcSlice->getRefPicListModification();
+  
+  Int maxRefListSize  = pcSlice->getNumRpsCurrTempList();
+  Int numTemporalRefs = maxRefListSize - vps->getNumDirectRefLayers( layer );
+
+
+  for (Int li = 0; li < 2; li ++) // Loop over lists L0 and L1
+  {
+    Int numModifications = 0;
+    
+    for( Int k = 0; k < ge.m_numInterViewRefPics; k++ ) 
+    {
+      numModifications +=  ( ge.m_interViewRefPosL[li][k] >= 0 ) ? 1 : 0; 
+    }
+
+    // set inter-view modifications
+    if( (maxRefListSize > 1) && (numModifications > 0) )
+    {
+      refPicListModification->setRefPicListModificationFlagL( li, true );
+      Int tempList[16];
+      for( Int k = 0; k < 16; k++ ) { tempList[k] = -1; }
+
+      Bool isModified = false;
+      for( Int k = 0; k < ge.m_numInterViewRefPics; k++ )
+      {
+        if( ge.m_interViewRefPosL[li][k] >= 0 )
+        {
+          Int orgIdx    = numTemporalRefs;
+          Int targetIdx = ge.m_interViewRefPosL[ li ][ k ];
+          for( Int idx = 0; idx < vps->getNumDirectRefLayers( layer ); idx++ )
+          {            
+            Int refLayer  = vps->getLayerIdInVps( vps->getRefLayerId( layer, idx ) );          
+            if( ( layer + ge.m_interViewRefs[ k ]) == refLayer )
+            {
+              tempList[ targetIdx ] = orgIdx;              
+              isModified = ( targetIdx != orgIdx  );
+            }
+            orgIdx++;
+          }
+        }
+      }
+      if( isModified )
+      {
+        Int temporalRefIdx = 0;
+        for( Int i = 0; i < pcSlice->getNumRefIdx( ( li == 0 ) ? REF_PIC_LIST_0 : REF_PIC_LIST_1 ); i++ )
+        {
+          if( tempList[i] >= 0 ) 
+          {
+            refPicListModification->setRefPicSetIdxL( li, i, tempList[i] );
+          }
+          else
+          {
+            refPicListModification->setRefPicSetIdxL( li, i, temporalRefIdx );
+            temporalRefIdx++;
+          }
+        }
+      }
+      else
+      {
+        refPicListModification->setRefPicListModificationFlagL( li, false );
+      }
+    }
+  }
+}
+#endif
 //! \}
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncGOP.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibEncoder/TEncGOP.h	(revision 368)
@@ -97,4 +97,15 @@
   SEIWriter               m_seiWriter;
   
+#if H_MV
+  TComPicLists*           m_ivPicLists;
+  std::vector<TComPic*>   m_refPicSetInterLayer; 
+
+  Int                     m_pocLastCoded;
+  Int                     m_layerId;  
+  Int                     m_viewId;
+#if H_3D
+  Bool                    m_isDepth;
+#endif
+#endif
   //--Adaptive Loop filter
   TEncSampleAdaptiveOffset*  m_pcSAO;
@@ -133,7 +144,20 @@
   
   Void  init        ( TEncTop* pcTEncTop );
+#if H_MV
+  Void  initGOP     ( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP);
+  Void  compressPicInGOP ( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsInGOP, Int iGOPid );
+#else
   Void  compressGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, TComList<TComPicYuv*>& rcListPicYuvRec, std::list<AccessUnit>& accessUnitsInGOP );
+#endif
   Void  xAttachSliceDataToNalUnit (OutputNALUnit& rNalu, TComOutputBitstream*& rpcBitstreamRedirect);
 
+#if H_MV
+  Int       getPocLastCoded  ()                 { return m_pocLastCoded; }  
+  Int       getLayerId       ()                 { return m_layerId;    }  
+  Int       getViewId        ()                 { return m_viewId;    }
+#if H_3D
+  Bool      getIsDepth       ()                 { return m_isDepth; }
+#endif
+#endif
 
   Int   getGOPSize()          { return  m_iGopSize;  }
@@ -141,5 +165,7 @@
   TComList<TComPic*>*   getListPic()      { return m_pcListPic; }
   
+#if !H_MV
   Void  printOutSummary      ( UInt uiNumAllPicCoded );
+#endif
   Void  preLoopFilterPicAll  ( TComPic* pcPic, UInt64& ruiDist, UInt64& ruiBits );
   
@@ -185,4 +211,7 @@
 #endif
 #endif
+#if H_MV
+   Void  xSetRefPicListModificationsMvc( TComSlice* pcSlice, UInt uiPOCCurr, UInt iGOPid );
+#endif
 #if L0386_DB_METRIC
   Void dblMetric( TComPic* pcPic, UInt uiNumSlices );
